<?php

$RED = "ff0000";
$GREEN = "00cf00";
$BLUE = "0000ff";
$YELLOW = "c8f526";

/* This "if" statement is to distinguish between the slave and master parameter sets */
if($servicedesc == "MySQL_Slave") {
  // {{{ Slave graphs (2)

  $ds_name[0] = "Seconds Behind Master";
  $opt[0] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[0] = "DEF:var3=$RRDFILE[3]:$DS[1]:AVERAGE " ;
  $def[0] .= "LINE1:var3#$BLUE:\"$NAME[3]\" " ;
  $def[0] .= "GPRINT:var3:LAST:\"%4.0lf %S last\" " ;
  $def[0] .= "GPRINT:var3:AVERAGE:\"%.0lf %S avg\" " ;
  $def[0] .= "GPRINT:var3:MAX:\"%.0lf %S max\\n\" ";

  $ds_name[1] = "Binlog";
  $opt[1] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[1] = "DEF:var1=$RRDFILE[1]:$DS[1]:AVERAGE " ;
  $def[1] .= "DEF:var2=$RRDFILE[2]:$DS[1]:AVERAGE " ;
  $def[1] .= "AREA:var1#$GREEN:\"$NAME[1]\" " ;
  $def[1] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[1] .= "GPRINT:var1:AVERAGE:\"%.0lf %S avg\" " ;
  $def[1] .= "GPRINT:var1:MAX:\"%.0lf %S max\\n\" " ;
  $def[1] .= "LINE1:var2#$BLUE:\"$NAME[2]\" " ;
  $def[1] .= "GPRINT:var2:LAST:\"%4.0lf %S last\" " ;
  $def[1] .= "GPRINT:var2:AVERAGE:\"%.0lf %S avg\" " ;
  $def[1] .= "GPRINT:var2:MAX:\"%.0lf %S max\\n\" ";

  // }}}

} else {

  $ds_name[0] = "Threads";
  $opt[0] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[0] = "DEF:var1=$RRDFILE[1]:$DS[1]:AVERAGE " ;
  $def[0] .= "DEF:var2=$RRDFILE[2]:$DS[1]:AVERAGE " ;
  $name1 = explode('_', $NAME[1]);
  $name2 = explode('_', $NAME[2]);
  $def[0] .= "LINE1:var1#$GREEN:\"$name1[1]\" " ;
  $def[0] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[0] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[0] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" " ;
  $def[0] .= "LINE1:var2#$BLUE:\"$name2[1]  \" " ;
  $def[0] .= "GPRINT:var2:LAST:\"%4.0lf %S last\" " ;
  $def[0] .= "GPRINT:var2:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[0] .= "GPRINT:var2:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[1] = "Queries per Second";
  $opt[1] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[1] = "DEF:var1=$RRDFILE[4]:$DS[1]:AVERAGE " ;
  $def[1] .= "DEF:var2=$RRDFILE[7]:$DS[1]:AVERAGE " ;
  $def[1] .= "DEF:var3=$RRDFILE[5]:$DS[1]:AVERAGE " ;
  $def[1] .= "LINE1:var1#$GREEN:\"Last interval      \" " ;
  $def[1] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[1] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[1] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" " ;
  $def[1] .= "LINE1:var2#$BLUE:\"Average since start\" " ;
  $def[1] .= "GPRINT:var2:LAST:\"%4.0lf %S last\" " ;
  $def[1] .= "GPRINT:var2:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[1] .= "GPRINT:var2:MAX:\"%4.0lf %S max\\n\" ";
  $def[1] .= "LINE1:var3#$RED:\"Slow Queries       \" " ;
  $def[1] .= "GPRINT:var3:LAST:\"%4.0lf %S last\" " ;
  $def[1] .= "GPRINT:var3:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[1] .= "GPRINT:var3:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[2] = "Queries in last 10 seconds";
  $opt[2] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[2]  = "DEF:var1=$RRDFILE[3]:$DS[1]:AVERAGE " ;
  $def[2] .= "LINE1:var1#$GREEN:\"Count \" " ;
  $def[2] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[2] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[2] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[3] = "Open tables";
  $opt[3] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[3]  = "DEF:var1=$RRDFILE[6]:$DS[1]:AVERAGE " ;
  $def[3] .= "LINE1:var1#$BLUE:\"Open tables \" " ;
  $def[3] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[3] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[3] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[4] = "Binlog Cache disk use";
  $opt[4] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[4]  = "DEF:var1=$RRDFILE[8]:$DS[1]:AVERAGE " ;
  $def[4] .= "LINE1:var1#$BLUE:\"Used \" " ;
  $def[4] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[4] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[4] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[5] = "Temporary tables created on disk";
  $opt[5] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[5]  = "DEF:var1=$RRDFILE[9]:$DS[1]:AVERAGE " ;
  $def[5] .= "LINE1:var1#$BLUE:\"Created \" " ;
  $def[5] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[5] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[5] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[6] = "Aborted clients";
  $opt[6] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[6]  = "DEF:var1=$RRDFILE[10]:$DS[1]:AVERAGE " ;
  $def[6] .= "LINE1:var1#$BLUE:\"Aborted \" " ;
  $def[6] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[6] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[6] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[7] = "Delays";
  $opt[7] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[7]  = "DEF:var1=$RRDFILE[11]:$DS[1]:AVERAGE " ;
  $def[7] .= "DEF:var2=$RRDFILE[12]:$DS[1]:AVERAGE " ;
  $def[7] .= "DEF:var3=$RRDFILE[13]:$DS[1]:AVERAGE " ;
  $def[7] .= "LINE1:var1#$BLUE:\"Errors   \" " ;
  $def[7] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[7] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[7] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";
  $def[7] .= "LINE1:var2#$GREEN:\"Inserts  \" " ;
  $def[7] .= "GPRINT:var2:LAST:\"%4.0lf %S last\" " ;
  $def[7] .= "GPRINT:var2:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[7] .= "GPRINT:var2:MAX:\"%4.0lf %S max\\n\" ";
  $def[7] .= "LINE1:var3#$RED:\"Writes   \" " ;
  $def[7] .= "GPRINT:var3:LAST:\"%4.0lf %S last\" " ;
  $def[7] .= "GPRINT:var3:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[7] .= "GPRINT:var3:MAX:\"%4.0lf %S max\\n\" ";

  $ds_name[8] = "InnoDB Pending actions";
  $opt[8] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[8]  = "DEF:var1=$RRDFILE[14]:$DS[1]:AVERAGE " ;
  $def[8] .= "DEF:var2=$RRDFILE[15]:$DS[1]:AVERAGE " ;
  $def[8] .= "DEF:var3=$RRDFILE[16]:$DS[1]:AVERAGE " ;
  $def[8] .= "LINE1:var1#$BLUE:\"Reads   \" " ;
  $def[8] .= "GPRINT:var1:LAST:\"%6.0lf %S last\" " ;
  $def[8] .= "GPRINT:var1:AVERAGE:\"%6.0lf %S avg\" " ;
  $def[8] .= "GPRINT:var1:MAX:\"%6.0lf %S max\\n\" ";
  $def[8] .= "LINE1:var2#$GREEN:\"Writes  \" " ;
  $def[8] .= "GPRINT:var2:LAST:\"%6.0lf %S last\" " ;
  $def[8] .= "GPRINT:var2:AVERAGE:\"%6.0lf %S avg\" " ;
  $def[8] .= "GPRINT:var2:MAX:\"%6.0lf %S max\\n\" ";
  $def[8] .= "LINE1:var3#$RED:\"fsyncs  \" " ;
  $def[8] .= "GPRINT:var3:LAST:\"%6.0lf %S last\" " ;
  $def[8] .= "GPRINT:var3:AVERAGE:\"%6.0lf %S avg\" " ;
  $def[8] .= "GPRINT:var3:MAX:\"%6.0lf %S max\\n\" ";

  $ds_name[9] = "InnoDB";
  $opt[9] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[9]  = "DEF:var1=$RRDFILE[17]:$DS[1]:AVERAGE " ;
  $def[9] .= "DEF:var2=$RRDFILE[18]:$DS[1]:AVERAGE " ;
  $def[9] .= "LINE1:var1#$BLUE:\"Reads   \" " ;
  $def[9] .= "GPRINT:var1:LAST:\"%6.0lf %S last\" " ;
  $def[9] .= "GPRINT:var1:AVERAGE:\"%6.0lf %S avg\" " ;
  $def[9] .= "GPRINT:var1:MAX:\"%6.0lf %S max\\n\" ";
  $def[9] .= "LINE1:var2#$GREEN:\"Writes  \" " ;
  $def[9] .= "GPRINT:var2:LAST:\"%6.0lf %S last\" " ;
  $def[9] .= "GPRINT:var2:AVERAGE:\"%6.0lf %S avg\" " ;
  $def[9] .= "GPRINT:var2:MAX:\"%6.0lf %S max\\n\" ";

  $ds_name[10] = "Slaves";
  $opt[10] = "--vertical-label \"\" --title \"$hostname / $servicedesc\"";
  $def[10]  = "DEF:var1=$RRDFILE[19]:$DS[1]:AVERAGE " ;
  $def[10] .= "LINE1:var1#$BLUE:\"Slave count \" " ;
  $def[10] .= "GPRINT:var1:LAST:\"%4.0lf %S last\" " ;
  $def[10] .= "GPRINT:var1:AVERAGE:\"%4.0lf %S avg\" " ;
  $def[10] .= "GPRINT:var1:MAX:\"%4.0lf %S max\\n\" ";

}
