def perfometer_check_mk_mysql(row, check_command, perf_data):
  if 'MySQL Slave' in row['service_description']:
    data = [x for x in perf_data if x[0] == 'Seconds_Behind_Master'][0]
    sbm = float(data[1])
    warn = float(data[3])
    crit = float(data[4])
    perc = 100 * sbm / crit
    if sbm <= warn:
      color = '#0f8'
      color2 = '#0f0'
    elif sbm <= crit:
      color = '#ff8'
      color2 = '#ff0'
    else:
      color = color2 = "#f22"
    return "%.1f seconds behind" % sbm, "<table><tr>" + perfometer_td(perc, color2) + perfometer_td(100 - perc, color) + "</tr></table>"
  else:
    qps = float([x[1] for x in perf_data if x[0] == 'Questions/sec'][0])
    if qps <= 1000: color = '#0f8'
    elif qps <= 10000: color = '#ff2'
    else: color = "#f22"
    return "%.1f queries/sec" % qps, perfometer_logarithmic(qps, 1000, 3, color)
  pass # Can't reach here.

perfometers['check_mk-MySQL'] = perfometer_check_mk_mysql
